# moebel.py
# veraendernde Methoden mit vordefinierten Parametern

from grafikfenster import *
from math import radians

### ---------------------------------------------------
class Moebel():
    """Klasse Moebel
    ermoeglicht das Zeichnen und Bearbeiten eines
    Moebel-Symbols fuer den Raumplaner"""
    
    def __init__(self, x, y, b, t, w, f, sichtbar):
        """Konstruktor"""
        self.__x=x
        self.__y=y
        self.__b=b
        self.__t=t
        self.__w=w
        self.__f=f
        self.__s=sichtbar
        if sichtbar: self.Zeige()

    def GibFigur(self):
        """definiert die zu zeichnende Figur,
        gibt hier einen leeren Pfad zurueck"""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()        
        return path
    
    def Transformiere(self, path):
        """Transformiert den uebergebenen Pfad"""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        gc.PushState()
        gc.Translate(self.__x+self.__b/2, self.__y+self.__t/2)
        gc.Rotate(radians(self.__w))
        gc.Translate(-self.__b/2, -self.__t/2)
        transformation = gc.GetTransform()
        gc.PopState()
        path.Transform(transformation)
        return path

    def GibX(self):
        """Get-Methode fuer x"""
        return self.__x
    
    def GibY(self):
        """Get-Methode fuer y"""
        return self.__y
    
    def GibBreite(self):
        """Get-Methode fuer die Breite"""
        return self.__b
    
    def GibTiefe(self):
        """Get-Methode fuer die Tiefe"""
        return self.__t
    
    def GibWinkel(self):
        """Get-Methode fuer den Winkel"""
        return self.__w
    
    def GibFarbe(self):
        """Get-Methode fuer die Farbe"""
        return self.__f
    
    def GibSichtbar(self):
        """Get-Methode fuer die Sichtbarkeit"""
        return self.__s

    def BewegeHorizontal(self, weite=1):
        """Veraendernde Methode fuer die x-Position"""
        self.Verberge()
        self.__x += weite
        self.Zeige()
    
    def BewegeVertikal(self, weite=1):
        """Veraendernde Methode fuer die y-Position"""
        self.Verberge()
        self.__y += weite
        self.Zeige()
    
    def Drehe(self, winkel=10):
        """Veraendernde Methode fuer die Orientierung [Winkel]"""
        self.Verberge()
        self.__w += winkel
        self.Zeige()

    def Verberge(self):
        """Veraendernde Methode fuer die Sichtbarkeit mit Wert False"""
        self.__s = False
        Zeichenflaeche.GibZeichenflaeche().Entferne(self)

    def Zeige(self):
        """Veraendernde Methode fuer die Sichtbarkeit mit Wert True"""
        self.__s = True
        Zeichenflaeche.GibZeichenflaeche().Zeichne(self)

### ---------------------------------------------------
class MoebelApp(wx.App):
    """Test-Anwendung speziell fuer Moebel"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.__fenster.ZeigeShellFrame()
        #self.__fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global moebel
        print('Konstruktor von Moebel nicht direkt aufrufen!')
        ##moebel=Moebel(20,20,40,40,0,"blue",True)
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = MoebelApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
