# -*- coding: utf-8 -*-
# raumplaner.py
"""App zum Projekt mit schrittweiser Ausfuehrung mit thread"""

from grafikfenster import *

from stuhl import *
from tisch import *
import time
import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='2': import thread as _thread
else: import _thread

### ---------------------------------------------------
class RaumplanerApp(wx.App):
    """Testanwendung fuer Raumplaner-Grafik
       ShellFrame: Interaktion mit laufender Anwendung
       FillingFrame: Anzeige der Umgebung"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        #self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Testanwendung mit threads"""
        print(__doc__)
        print("App-Attribute stuhl, tisch, sessel")
        self.tisch=Tisch(sichtbar=True)
        self.stuhl=Stuhl(sichtbar=True)
        _thread.start_new_thread(self.Action, (0.1, 30))
        
    def Action(self, sec, anzahl):
        """iterative Anwendung:"""
        for i in range(anzahl):
            self.tisch.BewegeHorizontal(2)
            self.tisch.BewegeVertikal(3)
            self.stuhl.BewegeHorizontal(1)
            self.stuhl.BewegeVertikal(5)
            self.stuhl.Drehe(3)
            time.sleep(sec)
                

### ---------------------------------------------------
if __name__ == '__main__':
    app = RaumplanerApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
