# -*- coding: utf-8 -*-
# stuhl.py
"""Demoversion mit mit thread"""

from grafikfenster import *
from math import radians
import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='2': import thread as _thread
else: import _thread
import time

from moebel import Moebel

### ---------------------------------------------------
class Stuhl(Moebel):
    """Klasse Stuhl
    ermoeglicht das Zeichnen und Bearbeiten eines
    Stuhl-Symbols fuer den Raumplaner"""
    
    def __init__(self,
                 xPos=20,
                 yPos=20,
                 breite=40,
                 tiefe=40,
                 winkel=0,
                 farbe="blue",
                 sichtbar=False):
        Moebel.__init__(self,xPos,yPos,breite,tiefe,winkel,farbe,sichtbar)
        
    def GibFigur(self):
        """Definiert die zu zeichnende Figur"""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        
        b,t=self.GibBreite(),self.GibTiefe()
        path.MoveToPoint(0, 0)
        path.AddLineToPoint(b, 0)
        path.AddLineToPoint(b*1.1, t)
        path.AddLineToPoint(-b*0.1, t)
        path.AddLineToPoint(0, 0)
        path.AddLineToPoint(0, -t*0.1)
        path.AddLineToPoint(b, -t*0.1)
        path.AddLineToPoint(b, 0)
        
        return self.Transformiere(path)

### ---------------------------------------------------
# hier mit Daten von Strings

class StuhlApp(wx.App):
    """Test-Anwendung speziell fuer Schritte bei Stuhl"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        print("Beispiel mit sehr langsamen Schritten (0.5 sec)")
        self.stuhl=Stuhl(30, 30, 40, 40, 270, 'blue', True)
        self.daten=[
            'self.stuhl.BewegeHorizontal(5)',
            'self.stuhl.BewegeVertikal(10)',
            'self.stuhl.Drehe(3)'
            ]
        _thread.start_new_thread(self.Action, (0.5, 20))

    def Action(self, sec, anzahl):
        """hier rekursiv verwendet"""
        eval(self.daten[anzahl%3])
        time.sleep(sec)
        if anzahl>0:
            self.Action(sec, anzahl-1)
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = StuhlApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
