# -*- coding: utf-8 -*-
# tisch.py
"""Demoversion mit mit thread"""

from grafikfenster import *
from math import radians
import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='2': import thread as _thread
else: import _thread
import time

from moebel import Moebel

### ---------------------------------------------------
class Tisch(Moebel):
    """Klasse Tisch
    ermoeglicht das Zeichnen und Bearbeiten eines
    Tisch-Symbols fuer den Raumplaner"""
    
    def __init__(self,
                 xPos=60,
                 yPos=10,
                 breite=120,
                 tiefe=60,
                 winkel=0,
                 farbe="red",
                 sichtbar=False):
        Moebel.__init__(self,xPos,yPos,breite,tiefe,winkel,farbe,sichtbar)
        
    def GibFigur(self):
        """Definiert die zu zeichnende Figur"""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        
        b,t=self.GibBreite(),self.GibTiefe()
        path.AddRectangle(0, 0, b, t)
        
        return self.Transformiere(path)

### ---------------------------------------------------
class TischApp(wx.App):
    """Test-Anwendung speziell fuer Tisch"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global tisch
        self.tisch=Tisch(70, 30, 120, 60, 0, 'red', True)
        self.tisch.BewegeVertikal(100)
        print("Beispiel mit sehr schneller Drehung")
        _thread.start_new_thread(self.Action, (0.01, 180))

    def Action(self, sec, anzahl):
        """hier rekursiv verwendet"""
        self.tisch.Drehe(1)
        time.sleep(sec)
        if anzahl>0:
            self.Action(sec, anzahl-1)

        
### ---------------------------------------------------
if __name__ == '__main__':
    app = TischApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
